class Person {
  def activities = []

  def methodMissing(String name, args) {
    println "*** intercepting call to $name"

    if(name.startsWith('play')) {
      def activity = name - 'play'

      if(activities.contains(activity)) {
        def impl = { Object[] theArgs ->
          println "I love to play $activity"
          if(theArgs) {
	    println " with ${theArgs.join(', ')}"
	  } else {
	    println ""
	  }
        }

	Person thisPerson = this
	thisPerson.metaClass."$name" = impl
	impl(args)
      } else {
        println "Sorry, I don't play $activity"
        //throw new MissingMethodException(name, Person, args)
      }
    } else {
      throw new MissingMethodException(name, Person, args)
    }
  }
}

def sam = new Person()

try {
  sam.run()
} catch(Exception ex) {
  println ex.message
}

sam.activities = ['Tennis', 'Football']

sam.playTennis()
sam.playTennis()
sam.playFootball()

sam.playPolitics()

